package com.sun.jndi.url.dns;

import javax.naming.NamingException;
import javax.naming.ConfigurationException;
import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.Name;
import javax.naming.spi.ObjectFactory;

public class dnsURLContextFactory implements ObjectFactory
{
    public dnsURLContextFactory() {
    }
    
    @Override
    public Object getObjectInstance(Object o, Name name, Context context, Hashtable<?, ?> hashtable) throws NamingException {
        if (o == null) {
            return new dnsURLContext(hashtable);
        }
        if ((o instanceof String)) {
            return getUsingURL((String)o, hashtable);
        }
        if ((o instanceof String[])) {
            return getUsingURLs((String[])(String[])o, hashtable);
        }
        throw new ConfigurationException("dnsURLContextFactory.getObjectInstance: argument must be a DNS URL String or an array of them");
    }
    
    private static Object getUsingURL(String name, Hashtable<?, ?> hashtable) throws NamingException {
        dnsURLContext dnsURLContext = new dnsURLContext(hashtable);
        try {
            return dnsURLContext.lookup(name);
        }
        finally {
            dnsURLContext.close();
        }
    }
    
    private static Object getUsingURLs(String[] array, Hashtable<?, ?> hashtable) throws NamingException {
        if (array.length == 0) {
            throw new ConfigurationException("dnsURLContextFactory: empty URL array");
        }
        dnsURLContext dnsURLContext = new dnsURLContext(hashtable);
        try {
            NamingException ex = null;
            int i = 0;
            while (i < array.length) {
                try {
                    return dnsURLContext.lookup(array[i]);
                }
                catch (NamingException ex2) {
                    ex = ex2;
                    ++i;
                }
            }
            throw ex;
        }
        finally {
            dnsURLContext.close();
        }
    }
}
